pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT > Class Template Referenceabstract
Module keypoints

Detects 2D AGAST corner points. More...

`#include <pcl/keypoints/agast_2d.h>`

Inheritance diagram for pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >:

## Public Types

typedef Keypoint< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef Keypoint< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef Keypoint< PointInT, PointOutT >::KdTree | KdTree
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::keypoints::agast::AbstractAgastDetector::Ptr | AgastDetectorPtr
Public Types inherited from pcl::Keypoint< PointInT, PointOutT >
typedef boost::shared_ptr< Keypoint< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Keypoint< PointInT, PointOutT > > | ConstPtr
typedef PCLBase< PointInT > | BaseClass
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(int, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, int index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| AgastKeypoint2DBase ()
| Constructor. More...
virtual | ~AgastKeypoint2DBase ()
| Destructor. More...
void | setThreshold (const double threshold)
| Sets the threshold for corner detection. More...
double | getThreshold ()
| Get the threshold for corner detection, as set by the user. More...
void | setMaxKeypoints (const unsigned int nr_max_keypoints)
| Sets the maximum number of keypoints to return. More...
unsigned int | getMaxKeypoints ()
| Get the maximum nuber of keypoints to return, as set by the user. More...
void | setMaxDataValue (const double bmax)
| Sets the max image data value (affects how many iterations AGAST does) More...
double | getMaxDataValue ()
| Get the bmax image value, as set by the user. More...
void | setNonMaxSuppression (const bool enabled)
| Sets whether non-max-suppression is applied or not. More...
bool | getNonMaxSuppression ()
| Returns whether non-max-suppression is applied or not. More...
void | setAgastDetector (const AgastDetectorPtr &detector)
AgastDetectorPtr | getAgastDetector ()
Public Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
| Keypoint ()
void | harrisCorner (ImageType &output, ImageType &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (ImageType &output, ImageType &input, const float sigma, bool SCALE)
void | hessianBlob (ImageType &output, ImageType &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (ImageType &output, ImageType &input1, ImageType &input2)
| Keypoint ()
| Empty constructor. More...
virtual | ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (int index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

bool | initCompute ()
| Initializes everything and checks whether input data is fine. More...
virtual void | detectKeypoints (PointCloudOut &output)=0
| Detects the keypoints. More...
Protected Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

IntensityT | intensity_
| Intensity field accessor. More...
double | threshold_
| Threshold for corner detection. More...
bool | apply_non_max_suppression_
| Determines whether non-max-suppression is activated. More...
double | bmax_
| Max image value. More...
AgastDetectorPtr | detector_
| The Agast detector to use. More...
unsigned int | nr_max_keypoints_
| The maximum number of keypoints to return. More...
Protected Attributes inherited from pcl::Keypoint< PointInT, PointOutT >
std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>
class pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >

Detects 2D AGAST corner points.

Based on the original work and paper reference by

  Elmar Mair, Gregory D. Hager, Darius Burschka, Michael Suppa, and Gerhard Hirzinger. Adaptive and generic corner detection based on the accelerated segment test. In Proceedings of the European Conference on Computer Vision (ECCV'10), September 2010.

Note
  This is an abstract base class. All children must implement a detectKeypoints method, based on the type of AGAST keypoint to be used.

Author
  Stefan Holzer, Radu B. Rusu

Definition at line 587 of file agast_2d.h.

## Member Typedef Documentation

## AgastDetectorPtr

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef pcl::keypoints::agast::AbstractAgastDetector::Ptr pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::AgastDetectorPtr

Definition at line 595 of file agast_2d.h.

## KdTree

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::KdTree pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::KdTree

Definition at line 592 of file agast_2d.h.

## PointCloudIn

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::PointCloudIn pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::PointCloudIn

Definition at line 590 of file agast_2d.h.

## PointCloudInConstPtr

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef PointCloudIn::ConstPtr pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::PointCloudInConstPtr

Definition at line 593 of file agast_2d.h.

## PointCloudOut

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::PointCloudOut pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::PointCloudOut

Definition at line 591 of file agast_2d.h.

## Constructor & Destructor Documentation

## AgastKeypoint2DBase()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::AgastKeypoint2DBase | ( |  | ) |

inline

Constructor.

Definition at line 603 of file agast_2d.h.

## ~AgastKeypoint2DBase()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

virtual pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::~AgastKeypoint2DBase | ( |  | ) |

inline virtual

Destructor.

Definition at line 614 of file agast_2d.h.

## Member Function Documentation

## detectKeypoints()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

virtual void pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::detectKeypoints | ( | PointCloudOut & | output | ) |

protected pure virtual

Detects the keypoints.

Parameters

  [out] | output | the resultant keypoints

Implements pcl::Keypoint< PointInT, PointOutT >.

Implemented in pcl::AgastKeypoint2D< pcl::PointXYZ, pcl::PointUV >, and pcl::AgastKeypoint2D< PointInT, PointOutT >.

## getAgastDetector()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

AgastDetectorPtr pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::getAgastDetector | ( |  | ) |

inline

Definition at line 690 of file agast_2d.h.

## getMaxDataValue()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

double pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::getMaxDataValue | ( |  | ) |

inline

Get the bmax image value, as set by the user.

Definition at line 662 of file agast_2d.h.

## getMaxKeypoints()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

unsigned int pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::getMaxKeypoints | ( |  | ) |

inline

Get the maximum nuber of keypoints to return, as set by the user.

Definition at line 646 of file agast_2d.h.

## getNonMaxSuppression()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

bool pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::getNonMaxSuppression | ( |  | ) |

inline

Returns whether non-max-suppression is applied or not.

Definition at line 678 of file agast_2d.h.

## getThreshold()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

double pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::getThreshold | ( |  | ) |

inline

Get the threshold for corner detection, as set by the user.

Definition at line 629 of file agast_2d.h.

## initCompute()

template<typename PointInT , typename PointOutT , typename IntensityT >

bool pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::initCompute | ( |  | ) |

protected virtual

Initializes everything and checks whether input data is fine.

Reimplemented from pcl::Keypoint< PointInT, PointOutT >.

Definition at line 46 of file agast_2d.hpp.

## setAgastDetector()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::setAgastDetector | ( | const AgastDetectorPtr & | detector | ) |

inline

Definition at line 684 of file agast_2d.h.

## setMaxDataValue()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::setMaxDataValue | ( | const double | bmax | ) |

inline

Sets the max image data value (affects how many iterations AGAST does)

Parameters

  [in] | bmax | the max image data value

Definition at line 655 of file agast_2d.h.

## setMaxKeypoints()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::setMaxKeypoints | ( | const unsigned int | nr_max_keypoints | ) |

inline

Sets the maximum number of keypoints to return.

The estimated keypoints are sorted by their internal score.

Parameters

  [in] | nr_max_keypoints | set the maximum number of keypoints to return

Definition at line 639 of file agast_2d.h.

## setNonMaxSuppression()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::setNonMaxSuppression | ( | const bool | enabled | ) |

inline

Sets whether non-max-suppression is applied or not.

Parameters

  [in] | enabled | determines whether non-max-suppression is enabled.

Definition at line 671 of file agast_2d.h.

## setThreshold()

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::setThreshold | ( | const double | threshold | ) |

inline

Sets the threshold for corner detection.

Parameters

  [in] | threshold | the threshold used for corner detection.

Definition at line 622 of file agast_2d.h.

## Member Data Documentation

## apply_non_max_suppression_

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

bool pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::apply_non_max_suppression_

protected

Determines whether non-max-suppression is activated.

Definition at line 713 of file agast_2d.h.

## bmax_

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

double pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::bmax_

protected

Max image value.

Definition at line 716 of file agast_2d.h.

## detector_

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

AgastDetectorPtr pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::detector_

protected

The Agast detector to use.

Definition at line 719 of file agast_2d.h.

## intensity_

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

IntensityT pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::intensity_

protected

Intensity field accessor.

Definition at line 707 of file agast_2d.h.

## nr_max_keypoints_

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

unsigned int pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::nr_max_keypoints_

protected

The maximum number of keypoints to return.

Definition at line 722 of file agast_2d.h.

## threshold_

template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

double pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >::threshold_

protected

Threshold for corner detection.

Definition at line 710 of file agast_2d.h.

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/keypoints/include/pcl/keypoints/agast_2d.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/keypoints/include/pcl/keypoints/impl/agast_2d.hpp